##### basic_socket::basic_socket (3 of 10 overloads)

Construct and open a `basic_socket`.

    basic_socket(
        const executor_type & ex,
        const protocol_type & protocol);

This constructor creates and opens a socket.

###### Parameters

ex

  The I/O executor that the socket will use, by default, to dispatch handlers for any asynchronous operations performed on the socket.

protocol

  An object specifying protocol parameters to be used.

###### Exceptions

asio::system_error

  Thrown on failure.